VERSION 5.00
Begin VB.Form ViewFonts 
   Caption         =   "View Fonts"
   ClientHeight    =   5385
   ClientLeft      =   5775
   ClientTop       =   5820
   ClientWidth     =   8535
   Icon            =   "ViewFonts.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   359
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   569
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton AboutButton 
      Caption         =   "About"
      Height          =   255
      Left            =   1680
      TabIndex        =   9
      Top             =   390
      Width           =   1335
   End
   Begin VB.Frame FontFrame 
      BorderStyle     =   0  'None
      Height          =   1815
      Left            =   3045
      TabIndex        =   7
      Top             =   0
      Width           =   3000
      Begin VB.Label Labels 
         AutoSize        =   -1  'True
         BackColor       =   &H8000000D&
         BackStyle       =   0  'Transparent
         Caption         =   "Font Text"
         BeginProperty Font 
            Name            =   "Script"
            Size            =   24
            Charset         =   255
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   540
         Index           =   0
         Left            =   0
         TabIndex        =   8
         Top             =   0
         Width           =   1275
      End
   End
   Begin VB.CheckBox CapFonts 
      Caption         =   "Cap displayed fonts to list"
      Height          =   375
      Left            =   1680
      TabIndex        =   4
      Top             =   0
      Value           =   1  'Checked
      Width           =   1335
   End
   Begin VB.TextBox FontText 
      Height          =   285
      Left            =   0
      TabIndex        =   3
      Text            =   "Font Text"
      Top             =   360
      Width           =   1575
   End
   Begin VB.CommandButton FontSizeDown 
      Caption         =   "-"
      Height          =   255
      Left            =   1320
      TabIndex        =   2
      Top             =   0
      Width           =   255
   End
   Begin VB.CommandButton FontSizeUp 
      Caption         =   "+"
      Height          =   255
      Left            =   1080
      TabIndex        =   1
      Top             =   0
      Width           =   255
   End
   Begin VB.TextBox FontSizeText 
      Height          =   285
      Left            =   720
      MaxLength       =   3
      TabIndex        =   0
      Text            =   "24"
      Top             =   -30
      Width           =   375
   End
   Begin VB.ListBox FontList 
      Height          =   2790
      Left            =   0
      Sorted          =   -1  'True
      TabIndex        =   5
      Top             =   720
      Width           =   3015
   End
   Begin VB.Label FontSizeLabel 
      AutoSize        =   -1  'True
      Caption         =   "Font Size: "
      Height          =   195
      Left            =   0
      TabIndex        =   6
      Top             =   0
      Width           =   750
   End
End
Attribute VB_Name = "ViewFonts"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Get the actual dimensions of the client
Private Declare Function GetClientRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

'Global variables
Private MyFontSize As Integer, BeforeCur As Integer, CurFontLabels As Integer 'Current font size, where the cursor last was in the font size box, and current number of font labels indexed

Private Sub Form_Load()
'Enumerate system fonts
Dim i As Integer
For i = 0 To Screen.FontCount - 1
    FontList.AddItem Screen.Fonts(i)
Next i

'Initialization
CurFontLabels = 1
FontSizeText_Change 'Will also call an update display
End Sub

Private Sub Form_Unload(Cancel As Integer) 'Terminate even if about box is still open
End
End Sub

'All the things that refresh the font display list
Private Sub Form_Resize()
UpdateDisplayList
End Sub

Private Sub FontList_Click()
UpdateDisplayList
End Sub

Private Sub FontList_Scroll()
UpdateDisplayList
End Sub

Private Sub FontText_Change() 'Only refresh display if we have text to display
If Trim(FontText.Text) <> "" Then UpdateDisplayList
End Sub

Private Sub CapFonts_Click()
UpdateDisplayList
End Sub

'Font sizes
Private Sub FontSizeText_Change() 'Keep font size numerical
If FontSizeText.Text = "" Then Exit Sub 'Allow blank, but remember last font size

If Trim(Val(FontSizeText.Text)) <> FontSizeText.Text Then 'If value is not a number, recover old font size
    FontSizeText.Text = MyFontSize
    FontSizeText.SelStart = BeforeCur
    FontSizeText.SelLength = 0
    Beep
Else
    MyFontSize = Val(FontSizeText.Text) 'Update the font size
    
    'Cap the font size
    If MyFontSize < 1 Then MyFontSize = 1
    FontSizeText.Text = Trim(MyFontSize)
    
    UpdateDisplayList
End If
End Sub

Private Sub FontSizeText_LostFocus() 'Confirm we have a valid font size entered when leaving the box
FontSizeText.Text = Trim(MyFontSize)
End Sub

Private Sub FontSizeText_KeyDown(KeyCode As Integer, Shift As Integer) 'If an invalid entry is made, keep the cursor position
BeforeCur = FontSizeText.SelStart
End Sub

Private Sub FontSizeDown_Click()
MyFontSize = MyFontSize - 1
FontSizeText.Text = Trim(MyFontSize)
End Sub

Private Sub FontSizeUp_Click()
MyFontSize = MyFontSize + 1
FontSizeText.Text = Trim(MyFontSize)
End Sub

'Other Stuff
Private Sub FontText_LostFocus() 'Make sure we have text to display
If Trim(FontText.Text) = "" Then FontText.Text = "Font Text"
End Sub

Private Sub Labels_Click(Index As Integer) 'Select a font name from its label
FontList.ListIndex = FontList.TopIndex + Index
End Sub

Private Sub AboutButton_Click() 'Show about form
Load AboutForm
AboutForm.Show
End Sub

'The main function
Private Sub UpdateDisplayList()
'Get the actual dimensions of the client
Dim RealWidth As Integer, RealHeight As Integer, GetClientDim As RECT
GetClientRect ViewFonts.hwnd, GetClientDim
RealWidth = GetClientDim.Right - GetClientDim.Left
RealHeight = GetClientDim.Bottom - GetClientDim.Top

'Determine number of potential text areas we will display
Const FontListBorder As Integer = 4, FontListItemHeight As Integer = 13
Dim MaxFonts As Integer, CurColLeft As Integer, CurFontTop As Integer, CurColWidth As Integer, CurFontOn As Integer
MaxFonts = CInt((RealHeight - FontList.Top - FontListBorder) / FontListItemHeight - 0.5) 'Round down the number of possible max fonts by how high the font list can get
CurColLeft = 0 'First col starts at 0 pixels in the frame
CurFontOn = 0 'Keeps track of the number of fonts drawn total

'Get the font frame ready - this is used for simultaneous refreshes, but unfortunately, also requires Twips be used instead of pixels for elements inside of it
FontFrame.Visible = False
FontFrame.Width = RealWidth - FontFrame.Left
FontFrame.Height = RealHeight

'Output all columns
Do 'Always draw at least one row
    Dim UnloadLast As Boolean
    'Start outputting a single column
    CurColWidth = 0
    CurFontTop = 0
    Do 'Always output at least 1 font per column
        On Error Resume Next
        Load Labels(CurFontOn) 'If label does not yet exist, load it
        
        With Labels(CurFontOn) 'Set all the properties
            .Caption = FontText.Text
            .FontSize = MyFontSize
            .FontName = FontList.List(FontList.TopIndex + CurFontOn)
            .Left = CurColLeft * Screen.TwipsPerPixelX
            .Top = CurFontTop * Screen.TwipsPerPixelY
            .Visible = True
            .BackStyle = 0 'Show no background - 0=Transparent
            If CurFontOn = FontList.ListIndex - FontList.TopIndex Then .BackStyle = 1 'Show selected background - 1=Opaque
            
            CurFontTop = CurFontTop + (.Height / Screen.TwipsPerPixelY) + 3
            If (.Top + .Height) / Screen.TwipsPerPixelY > RealHeight Then 'If font overlapped form border, we will need to draw it again
                .Visible = False 'Just hide it, don't worry about unloading for a single item
            Else
                If (.Width / Screen.TwipsPerPixelX) > CurColWidth Then CurColWidth = (.Width / Screen.TwipsPerPixelX) 'Update column width
                CurFontOn = CurFontOn + 1 'Increment the current font label number
            End If
        End With
    Loop While CurFontTop < RealHeight And (CurFontOn < MaxFonts Or CapFonts.Value = 0) And FontList.TopIndex + CurFontOn < FontList.ListCount 'Loop until font overlaps form border
    
    CurColLeft = CurColLeft + CurColWidth 'Prepare for the next column
Loop While CurColLeft + (Labels(0).Width / Screen.TwipsPerPixelX / 2) < RealWidth - FontFrame.Left And (CurFontOn < MaxFonts Or CapFonts.Value = 0) And FontList.TopIndex + CurFontOn < FontList.ListCount 'Keep drawing columns while at least a half of the font string would still be displayed

'Update label count
Dim i As Integer
For i = CurFontOn To CurFontLabels - 1 'Hide unused labels
    Labels(i).Visible = False
Next i
CurFontLabels = CurFontOn

FontFrame.Visible = True 'Refresh the frame

'Expand the font list to show the number of fonts currently being displayed (up to its max height so it doesn't scroll off the screen)
If CurFontOn > MaxFonts Then CurFontOn = MaxFonts
FontList.Height = CurFontOn * FontListItemHeight + FontListBorder
End Sub
